org.apache.felix.ipojo.composite.service.provides

## Class CompositionMetadata

- java.lang.Object
- - org.apache.felix.ipojo.composite.service.provides.CompositionMetadata

    public class CompositionMetadata
    extends java.lang.Object

Check and build a composition, i.e. a POJO containing the composition.

Author:
  Felix Project Team

### Constructor Summary

Constructors
Constructor and Description
`CompositionMetadata(org.osgi.framework.BundleContext context, org.apache.felix.ipojo.metadata.Element description, ProvidedServiceHandler psh, java.lang.String name)` Constructor.

### Method Summary

All Methods Instance Methods Concrete Methods
`protected void` `buildMapping()` Build the delegation mapping.
`protected org.apache.felix.ipojo.metadata.Element` `buildMetadata(java.lang.String name)` Build service implementation metadata.
`protected byte[]` `buildPOJO()` Build a service implementation.
`protected org.osgi.framework.BundleContext` `getBundleContext()`
`java.util.List` `getFieldList()` Get the field list to use for the delegation.
`java.lang.String` `getName()`
`SpecificationMetadata` `getSpecificationMetadata()`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### CompositionMetadata

    public CompositionMetadata(org.osgi.framework.BundleContext context,
                               org.apache.felix.ipojo.metadata.Element description,
                               ProvidedServiceHandler psh,
                               java.lang.String name)

Constructor.

Parameters:
  `context` - : bundle context
  `description` - : 'provides' element
  `psh` - : parent handler
  `name` - : name of the composition.

### Method Detail

#### getBundleContext

    protected org.osgi.framework.BundleContext getBundleContext()

#### getName

    public java.lang.String getName()

#### getSpecificationMetadata

    public SpecificationMetadata getSpecificationMetadata()

#### buildMapping

    protected void buildMapping()
                         throws CompositionException

Build the delegation mapping.

Throws:
  `CompositionException` - : occurs when the mapping cannot be inferred correctly

#### buildPOJO

    protected byte[] buildPOJO()

Build a service implementation.

Returns:
  the byte[] of the POJO.

#### buildMetadata

    protected org.apache.felix.ipojo.metadata.Element buildMetadata(java.lang.String name)

Build service implementation metadata.

Parameters:
  `name` - : name of the future instance (used to avoid cycle)
Returns:
  Component Type metadata.

#### getFieldList

    public java.util.List getFieldList()

Get the field list to use for the delegation.

Returns:
  the field list.